Jagguar Game Engine

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | Private Attributes | List of all members
GameMakerGUI Class Reference

`#include <GameMakerGUI.hpp>`

## Public Member Functions
| GameMakerGUI (SDL_Window *window, SDL_Renderer *renderer, std::vector< GameObject * > *gameObjects)
| ~GameMakerGUI ()
void | Input (SDL_Event e)
void | RenderEditor (IGraphicsEngineRenderer *mRenderer, bool *runGame)

## Private Member Functions
void | ShowGameObjectWindow ()
void | ShowDebugWindow ()
void | CreateNewGameObject ()
void | EditGameObject ()
void | CreateComponent (IGraphicsEngineRenderer *ren)
TransformComponent * | FindTransform (GameObject *curObj)

## Private Attributes
std::vector< GameObject * > * | m_gameobjects

## Detailed Description

The GUI creating the game editor. Displays menus allowing for creation, editing, and destruction of all `GameObjects` and `Components`

## Constructor & Destructor Documentation

## ◆ GameMakerGUI()

GameMakerGUI::GameMakerGUI | ( | SDL_Window * | window,
|  | SDL_Renderer * | renderer,
|  | std::vector< GameObject * > * | gameObjects
| ) |  |

Construct a new Game Maker GUI object

Parameters

  window | the window to be drawn to
  renderer | the renderer to be drawn to
  gameObjects | all game objects in the game

See also
  Engine::InitializeGUI()
  Engine::Render()

## ◆ ~GameMakerGUI()

GameMakerGUI::~GameMakerGUI | ( |  | ) |

Destroy the Game Maker GUI object

## Member Function Documentation

## ◆ CreateComponent()

void GameMakerGUI::CreateComponent | ( | IGraphicsEngineRenderer * | ren | ) |
| private

Displays a window to create a new Component

Parameters

  ren | the renderer a new component might need

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ CreateNewGameObject()

void GameMakerGUI::CreateNewGameObject | ( |  | ) |
| private

Displays a window to create a new GameObject.

Here is the caller graph for this function:

## ◆ EditGameObject()

void GameMakerGUI::EditGameObject | ( |  | ) |
| private

Displays a window to edit a GameObject.

See also
  CreateComponent()

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ FindTransform()

TransformComponent * GameMakerGUI::FindTransform | ( | GameObject * | curObj | ) |
| private

Gets a TransformComponent attached to the given GameObject

Parameters

  curObj | the game object being checked

Returns
  a TransformComponent attached to curObj

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ Input()

void GameMakerGUI::Input | ( | SDL_Event | e | ) |

Forwards all input on to ImGui

Here is the caller graph for this function:

## ◆ RenderEditor()

void GameMakerGUI::RenderEditor | ( | IGraphicsEngineRenderer * | mRenderer,
|  | bool * | runGame
| ) |  |

The main function to draw the GUI. Dispatches member functions to draw various editor menus.

Parameters

  mRenderer | the renderer to be drawn to
  runGame | pointer to the bool controlling Engine#MainGameLoop()

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ ShowDebugWindow()

void GameMakerGUI::ShowDebugWindow | ( |  | ) |
| private

Displays internal GUI static variables for debugging purposes.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ ShowGameObjectWindow()

void GameMakerGUI::ShowGameObjectWindow | ( |  | ) |
| private

Displays a window containing all GameObjects.

See also
  CreateNewGameObject()
  EditGameObject()

Here is the call graph for this function:
Here is the caller graph for this function:

## Member Data Documentation

## ◆ m_gameobjects

std::vector<GameObject *>* GameMakerGUI::m_gameobjects
| private

Pointers to all the game objects in the Engine.

The documentation for this class was generated from the following files:

- include/GameMakerGUI.hpp
- src/GameMakerGUI.cpp